<template>

    <div id="app">
        <div class="cg-font-preview-input">
        <input type="text" class="font1 cg-product-font-custom-preview-box second add-btm-xsml" v-model="message">
            <select class="cg-font-preview-size" v-model="font_size" @change="changeFontSize()">
                <option value="24">24 px</option>
                <option value="36">36 px</option>
                <option value="48">48 px</option>
                <option value="60">60 px</option>
            </select>
        </div>
        <div class="font-preview-scroll-wrap">
        <div class="cg-font-preview-img-wrap" v-for="font in fonts_">
            <h4 class="cg-product-font-preview-content-thin light-grey w600 f13">{{ font.name }}</h4>
            <div :id="'font'+font.id" class="font_size_wrap">{{ message }}</div>
            </div>
        </div>
    </div>

</template>

<!--<style lang="scss" scoped  v-for="font in fonts_">-->
<!--    @font-face {-->
<!--        font-family: Qiko;-->
<!--        src: url(http://127.0.0.1:8000/storage/uploads/products/Qiko.ttf);-->
<!--    }-->
<!--</style>-->



<style lang="scss" scoped>
    .fontsz{
        font-size: 24px;
        font-display:block;
    }
    .font-small{
        font-size: 12px;
        font-display:block;
    }
    .font-normal{
        font-size: 24px;
        font-display:block;
    }
    .font-large{
        font-size: 48px;
        font-display:block;
    }

</style>


<script>
    export default {
        name: 'app',
        data () {
            return {
                fonts_:[],
                style_1:"",
                font_size:24,
                items: [
                    { message: 'Foo' },
                    { message: 'Bar' }
                ],
                message: 'Two driven jocks help fax my big quiz.'
            }
        },
        methods: {
            fetchFonts(product_id) {
                axios.get('/fetch_fonts?product_id=' + product_id)
                    .then(response => {
                        this.fonts_ = response.data.data;
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
            changeFontSize: function() {
                var x = document.getElementsByClassName("font_size_wrap");
                for (var i = 0; i < x.length; i++) {
                    x[i].style.fontSize=this.font_size+"px";
                }
            },

        },
        beforeCreate() {
            // alert('before hook has been called');

        },
        mounted() {
            var segment_str = window.location.pathname;
            var segment_array = segment_str.split( '/' );
            var product_id = segment_array.pop();
            this.fetchFonts(product_id);
            var x = document.getElementsByClassName("font_size_wrap");
            for (var i = 0; i < x.length; i++) {
                x[i].style.fontSize=this.font_size+"px";
            }
        },
        updated() {
            // alert('updated hook has been called');
            $.each(this.fonts_, function(key, value) {
                var junction_font = new FontFace(value.name, 'url('+ value.font_path +'uploads/products/font_previews/'+ value.product_id +'/'+ value.file +')');
                junction_font.load().then(function(loaded_face) {
                    document.fonts.add(loaded_face);
                    document.getElementById('font'+value.id).style.fontFamily = value.name;
                }).catch(function(error) {
                    // error occurred
                });

            });


        }
    }

</script>
